package fi.em.formPlugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.BillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.list.BillList;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

public class BusinessProcessingListPlugin extends AbstractListPlugin {
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"toolbarap"});
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        String itemKey = evt.getItemKey();
        if ("nckd_trackup".equals(itemKey)) {
            BillList billList = (BillList) this.getControl("billlistap");
            ListSelectedRowCollection list = billList.getSelectedRows();
            if (list.size() == 0) {
                this.getView().showMessage("请选择一条数据");
                return;
            } else if (list.size() > 1) {
                this.getView().showMessage("只能选择一条数据");
                return;
            }
            Object[] primaryKeyValues = list.getPrimaryKeyValues();
            long id = 0;
            String type = null;
            for (Object pk : primaryKeyValues) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(pk, "nckd_ywcld");
                id = info.getLong("nckd_mid_assert");
                type = info.getString("nckd_source_type");
                if (id == 0 || StringUtils.isEmpty(type)) {
                    this.getView().showMessage("该数据不是由中间表生成,无法上查到中间表");
                    return;
                }
            }
            BillShowParameter showParameter = new BillShowParameter();

            showParameter.setFormId(type);

            showParameter.getOpenStyle().setShowType(ShowType.Modal);//打开方式

            showParameter.setPkId(id);

            this.getView().showForm(showParameter);
        }
    }
}
